Liferay.Loader.define("frontend-js-metal-web@1.0.24/metal-jsx/src/iDOMHelpers", ['exports', 'metal-incremental-dom/src/all/incremental-dom', './JSXRenderer'], function (exports, _incrementalDom, _JSXRenderer) {
	'use strict';

	Object.defineProperty(exports, "__esModule", {
		value: true
	});

	var _incrementalDom2 = _interopRequireDefault(_incrementalDom);

	var _JSXRenderer2 = _interopRequireDefault(_JSXRenderer);

	function _interopRequireDefault(obj) {
		return obj && obj.__esModule ? obj : {
			default: obj
		};
	}

	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
		return typeof obj;
	} : function (obj) {
		return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
	};

	/**
  * These helpers are all from "babel-plugin-incremental-dom". See its README
  * file for more details:
  * https://github.com/jridgewell/babel-plugin-incremental-dom#runtime
  */

	var scope = typeof exports !== 'undefined' && typeof global !== 'undefined' ? global : window;

	scope.iDOMHelpers = scope.iDOMHelpers || {};

	scope.iDOMHelpers.attr = function (value, attrName) {
		IncrementalDOM.attr(attrName, value);
	};

	scope.iDOMHelpers.forOwn = function (object, iterator) {
		var hasOwn = Object.prototype.hasOwnProperty;
		for (var prop in object) {
			if (hasOwn.call(object, prop)) {
				iterator(object[prop], prop);
			}
		}
	};

	scope.iDOMHelpers.jsxWrapper = function (elementClosure, args) {
		var wrapper = args ? function () {
			return elementClosure.apply(this, args); // eslint-disable-line
		} : elementClosure;
		wrapper.__jsxDOMWrapper = true;
		return wrapper;
	};

	scope.iDOMHelpers.renderArbitrary = function (child) {
		var type = typeof child === 'undefined' ? 'undefined' : _typeof(child);
		if (type === 'number' || type === 'string' || child && child instanceof String) {
			IncrementalDOM.text(child);
		} else if (type === 'function' && child.__jsxDOMWrapper) {
			child();
		} else if (Array.isArray(child)) {
			child.forEach(scope.iDOMHelpers.renderArbitrary);
		} else if (String(child) === '[object Object]') {
			// Renders special incremental dom nodes in a special way :)
			if (_incrementalDom2.default.isIncDomNode(child)) {
				_incrementalDom2.default.renderChild(child);
			} else {
				scope.iDOMHelpers.forOwn(child, scope.iDOMHelpers.renderArbitrary);
			}
		} else if (!child) {
			_JSXRenderer2.default.skipChild();
		}
	};

	exports.default = scope.iDOMHelpers;
});
//# sourceMappingURL=iDOMHelpers.js.map
